#ifndef BLD_ENV_H
#define BLD_ENV_H

/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <gpl/gpl.h>
#include <bld/scope.h>

/***********************************************************************
class BLD_Environment

***********************************************************************/
class BLD_Environment
{
	public:
		virtual ~BLD_Environment(void);

		static BLD_Environment *GetEnvironment(void);
		GPL_Boolean GetValue(const GPL_String & name,
								GPL_String & value) const;

		void SetEnvironmentVariables(char **e) { envp = e; }

		GPL_Boolean Execute(const GPL_String & command,
							GPL_String & output, GPL_Boolean inlinePrint) const;
		GPL_Boolean Execute(const GPL_String & program,
							const GPL_Array<GPL_String> & arguments,
							GPL_String & output,
							GPL_Boolean inlinePrint) const;

		static GPL_Array<GPL_String> Split(const GPL_String & text);

	protected:
		static BLD_Environment *singleton;
		char **envp;

		BLD_Environment(void);
};

#endif /* BLD_ENV_H */
