/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <bld/pragmaop.h>
#include <bld/interp.h>

/***********************************************************************
class BLD_PragmaOperation
***********************************************************************/
BLD_Value BLD_PragmaOperation::Perform(void) const
{
	return BLD_Value();
}

GPL_String BLD_PragmaOperation::ToString(void) const
{
	return "pragma";
}

/***********************************************************************
class BLD_PragmaDumpOperation
***********************************************************************/
BLD_Value BLD_PragmaDumpOperation::Perform(void) const
{
	if (dumpTopOnly)
	{
	}
	else
	{
		BLD_APP->DumpStates();
	}
	return BLD_Value::truth;
}

GPL_String BLD_PragmaDumpOperation::ToString(void) const
{
	GPL_String image = BLD_PragmaOperation::ToString();
	image.Append(" dump");
	if (dumpTopOnly)
	{
		image.Append(" top");
	}
	return image;
}

/***********************************************************************
class BLD_PragmaEnvOperation
***********************************************************************/
BLD_Value BLD_PragmaEnvOperation::Perform(void) const
{
	BLD_APP->DumpEnvironment();
	return BLD_Value::truth;
}

GPL_String BLD_PragmaEnvOperation::ToString(void) const
{
	GPL_String image = BLD_PragmaOperation::ToString();
	image.Append(" env");
	return image;
}
