#ifndef BLD_TARGET_H
#define BLD_TARGET_H

/******************************************************************************

Copyright (c) 1997, Andrew J. Weber, Jason P. Weber

Copyright information should have been included with this distribution
and may be found at ../meta/COPYRIGHT or obtained via email from weber@acm.org

******************************************************************************/

#include <gpl/gpl.h>
#include <bld/op.h>
#include <bld/block.h>
#include <bld/rule.h>

/***********************************************************************
class BLD_BuildStatus
***********************************************************************/
enum BLD_BuildStatus
{
	BLD_BUILD_FAILED		=	-1,
	BLD_BUILD_UNNECESSARY	=	0,
	BLD_BUILD_NEEDED		=	1
};

/***********************************************************************
class BLD_Target

***********************************************************************/
class BLD_Target
{
	public:
		static GPL_Stack<BLD_Target*> targets;

		BLD_Target(void);
		virtual ~BLD_Target(void);

		inline const GPL_String & GetName(void) const { return name; }

		inline void SetName(const GPL_String & n) { name = n; }
		void Terminate(void) { block.Terminate(); }
		GPL_Boolean AddRule(const BLD_RuleBase * rule,
							const GPL_Array<GPL_String> & expressions);
		void IncludeOperations(const OpArray & ops) { block.IncludeOperations(ops); }
		virtual BLD_BuildStatus Build(const GPL_Boolean reuseScope = FALSE);

		static void SetExecuted(void);
		static void SetFailed(void);

	private:
		BLD_Block block;
		GPL_String name;
};

#endif /* BLD_TARGET_H */
